`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    18:06:09 04/18/2013 
// Design Name: 
// Module Name:    Positioner 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////


// y=10*C.*sin(@)*t -0.05*t^2//
module Positioner(mainclk, xvalue,reset,yvalue);

input mainclk,reset;
output [10:0] xvalue,yvalue;
//reg [10:0] xvalue,yvalue;


//----------------Values for Countererers ------------
reg [31:0]Counterer=0;
reg clk100ms=0;
reg resett=0;
reg [31:0] timer=0;
reg [10:0]resetcore=0;
reg corereset;// clck for reseting core

//----------------Hard coded values for trails--------------
wire [31:0]ten=32'h4120_0000;// ten
wire [31:0]elastic=32'h3F80_0000;// hardcodedelastic things feed from cpu or something
wire [31:0] sine =32'h3F80_0000; // hardcoded vlaues from cpu for sine
wire [31:0] zeropoint5=32'h3D4C_CCCD;// 0.05 value used in claculting y

// ---------------states values---------------
reg [4:0]currentstate;
parameter resetall=5'b00000;//0
parameter changet2f=5'b00001;//1
parameter multenbyc=5'b00010;//2
parameter sinbyt=5'b00011;// 3
parameter mul3by2=5'b00100;//4
parameter tbyt=5'b00101;//5
parameter point5bytt=5'b00110;// 6
parameter subration=5'b00111;// 7;
parameter intermediate1=5'b01000;// 8;
parameter intermediate2=5'b01001;// 9;
parameter intermediate3=5'b1010;// 10;
parameter intermediate4=5'b01011;// 11;
parameter intermediate5=5'b01100;// 12;
parameter intermediate6=5'b01101;// 13;
parameter intermediate7=5'b01110;// 14;
parameter finalstate=5'b01111;// 15;
parameter intermediate0=5'b10000;// 16;
//---------------------------------------------

// ---------Controls for cores cores------------
// int to float
wire [31:0] result_i2f;
reg [31:0] tfloat;
reg [31:0] input_2int2f;
 

Firsty init2float (
  .a(input_2int2f), // input [31 : 0] a
  .clk(mainclk), // input clk
  .result(result_i2f) // output [31 : 0] result
);



wire [31:0] result_MUL;
reg [31:0] state2results;  // holds step 2 results 
reg [31:0]state3result; // holds results for state 3 mul
reg [31:0]state4result; // holds results for state 3 mul
reg [31:0]state5result; // holds results for state 3 mul
reg [31:0]state6result; // holds results for state 3 mul
reg [31:0]state7result; // holds results for state 3 mul
wire [31:0] a_mul; // a inputs to multiplication
wire [31:0] b_mul; //b inputs to multiplication
 

MUL multiply (
  .a(a_mul), // input [31 : 0] a
  .b(b_mul), // input [31 : 0] b
  .clk(mainclk), // input clk
  .result(result_MUL) // output [31 : 0] result
);


 
wire [31:0]result_SUB; // holds results for state 3 mul

SUB substration (
  .a(state4result), // input [31 : 0] a
  .b(state6result), // input [31 : 0] b
  .clk(mainclk), // input clk
  .result(result_SUB) // output [31 : 0] result
);
 
wire [31:0] result_f2i;
reg [31:0] Yfloat;

Ftoint float_int (
  .a(result_SUB), // input [31 : 0] a
  .clk(mainclk), // input clk
  .result(result_f2i) // output [31 : 0] result
);


assign a_mul = (currentstate == multenbyc) ? ten 
            : (currentstate ==  sinbyt) ? sine	
            : (currentstate ==  mul3by2) ? state3result
	         : (currentstate == tbyt)? tfloat
            : (currentstate == point5bytt) ? state5result
	         : 0; 	// just to be safe

assign b_mul = (currentstate == multenbyc) ? elastic 
            : (currentstate ==  sinbyt) ? tfloat	
            : (currentstate ==  mul3by2) ? state2results
	         : (currentstate == tbyt)? tfloat
            : (currentstate == point5bytt) ? zeropoint5
	         : 0; 	// just to be safe
	

// --------------Countererer for 100ms and main state machine------------------------
always @ (posedge mainclk)
begin
         
        //------100ms clck-------------
			  if(Counterer==5000000) //5000000
					begin
					 Counterer<=0;
					 clk100ms<=~clk100ms;
					end 
				else
				 begin
				 Counterer<=Counterer+1;
				 end
		 //---------------------------------
		 
		 
		 
			 if(corereset)
					begin
						resetcore<=0;
					end 
				else
						resetcore<=resetcore+1;
	
					 
       //-------------------state machine-------------------------
			case(currentstate)
						 resetall:   begin
										 
										    input_2int2f=timer;
										    currentstate=intermediate0;
												 //end
										 end
										 
					intermediate0: begin 
					                   
						                  currentstate=changet2f;
                                end						
						 changet2f:  begin
											corereset<=0;
											 if(resetcore==35)
												begin
													currentstate=intermediate1;
													corereset<=1;
												end
											end
											
												
					intermediate1:	 begin
													currentstate=multenbyc;
					                end
										 
										 
										 
						 multenbyc:  begin
						               corereset<=0;
											if(resetcore==35)
											  begin
													  state2results=result_MUL;  // 10
													  tfloat=result_i2f;  /// do this here 
													  currentstate=intermediate2;
													  corereset<=1;
											  end							  
										end
										
										
					intermediate2:	 begin
					                    currentstate=sinbyt;
					                end
						
										
						 sinbyt:     begin
												corereset<=0;
												if(resetcore==35)
												  begin
														  state3result=result_MUL;  // 1*19 =tfloat
														  currentstate=intermediate3;
														  corereset<=1;
												  end
										 end
										 
										 
					intermediate3:	 begin
					              
					                        currentstate=mul3by2;
					                end	
										 
						 mul3by2:    begin
						                  corereset<=0;
												if(resetcore==35)
												  begin
														  state4result=result_MUL;  // 1*19 =tfloat
														  currentstate=intermediate4;
														  corereset<=1;
												  end 
										 end
										 
					intermediate4:	 begin
					                        currentstate=tbyt;
					                end	
										 
						 tbyt:       begin
						                 corereset<=0;
												if(resetcore==35)
												  begin
														  state5result=result_MUL;  // 1*19 =tfloat
														  currentstate=intermediate5;
														  corereset<=1;
												  end 
										 end
					intermediate5:	 begin   
					                        currentstate=point5bytt;
					                end		 
										 
						 point5bytt: begin
						                 corereset<=0;
												if(resetcore==35)
												  begin
														  state6result=result_MUL;  // 1*19 =tfloat
														  currentstate=intermediate6;
														  corereset<=1;
												  end 
										 end
										 
					intermediate6:	 begin
					                        currentstate=subration;
					                end		
										 
						 subration:  begin
						                  corereset<=0;
												if(resetcore==35)
												  begin
														  state7result=result_SUB;  // 1*19 =tfloat
														  currentstate=intermediate7;
														  corereset<=1;
												  end 
										 end
				intermediate7:	    begin
					                        currentstate=finalstate;
					                end	
             finalstate:		begin
				                        corereset<=0;
												if(resetcore==35)
												  begin
														  Yfloat=result_f2i;  // 1*19 =tfloat
														  currentstate=resetall;
														  corereset<=1;
												  end 
                              end				 
					
						 default: currentstate=resetall;
			 endcase     		 
								 
 end // always 

assign yvalue=result_f2i[10:0];


// ---------time runnign at 100ms ----------------------------------------------
always @ (posedge clk100ms)                // Countererer that controls how fast on screen
   begin
				if(resett==1)
				  timer<=1;
				  else	
	                           // just for testing
					timer<=timer+1;
	end
//------------------------------------------------------------------------------------		
		


endmodule
