`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    07:42:59 02/22/2011 
// Design Name: 
// Module Name:    chargen - Behavioral
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module chargen(clk25, hcount, vcount, blank, ASCII_CHAR, R2, R1, R0, G2, G1, G0, B1, B0);

input clk25;
input [10:0]hcount, vcount;
input blank;
input [6:0]ASCII_CHAR;
output R2, R1, R0, G2, G1, G0, B1, B0;

wire [2:0]PIXEL_ROW,PIXEL_COL;
wire [15:0]ROM_ADDRESS;
wire [7:0]ROM_DATA;

reg [2:0]col1,col2,col3;
reg INTENSITY;

// ----------- Instantiating ROM -------------------
rom1kx8 mem1 (
    .clka(clk25),
    .addra(ROM_ADDRESS), // Bus [9 : 0] 
    .douta(ROM_DATA)); // Bus [7 : 0] 


assign PIXEL_ROW = vcal0ount[2:0];
assign PIXEL_COL = hcount[2:0];

assign ROM_ADDRESS = {ASCII_CHAR,PIXEL_ROW};	// Generating ROM address

always @(posedge clk25)
 begin
  col3 <= col2;
  col2 <= col1;
  col1 <= PIXEL_COL;
  INTENSITY <= ROM_DATA[col3];
 // INTENSITY <= ROM_DATA[PIXEL_COL];
 end

assign R2 = (blank == 0) ? INTENSITY : 1'b0;
assign R1 = (blank == 0) ? INTENSITY : 1'b0;
assign R0 = (blank == 0) ? INTENSITY : 1'b0;
assign G2 = (blank == 0) ? INTENSITY : 1'b0;
assign G1 = (blank == 0) ? INTENSITY : 1'b0;
assign G0 = (blank == 0) ? INTENSITY : 1'b0;
assign B1 = (blank == 0) ? INTENSITY : 1'b0;
assign B0 = (blank == 0) ? INTENSITY : 1'b0;

		
endmodule
